Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 2829)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 2830)
@@ -6,4 +6,5 @@
 		ConfigMerger.exe = ConfigMerger.exe
 		..\documentation\License\gpl-3.0.txt = ..\documentation\License\gpl-3.0.txt
+		HeuristicLab 3.3.vsmdi = HeuristicLab 3.3.vsmdi
 		LocalTestRun.testrunconfig = LocalTestRun.testrunconfig
 		PreBuildEvent.cmd = PreBuildEvent.cmd
@@ -149,5 +150,10 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Routing.TSP.Views-3.3", "HeuristicLab.Routing.TSP.Views\3.3\HeuristicLab.Routing.TSP.Views-3.3.csproj", "{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SGA-3.3.Tests", "HeuristicLab.SGA\3.3\Tests\HeuristicLab.SGA-3.3.Tests.csproj", "{F42F3576-7233-4B28-90F7-36AE15F30F92}"
+EndProject
 Global
+	GlobalSection(TestCaseManagementSettings) = postSolution
+		CategoryFile = HeuristicLab 3.3.vsmdi
+	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		Debug|Any CPU = Debug|Any CPU
@@ -661,4 +667,12 @@
 		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.ActiveCfg = Release|Any CPU
 		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.ActiveCfg = Release|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|Any CPU.Build.0 = Release|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x64.ActiveCfg = Release|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab 3.3.vsmdi
===================================================================
--- /trunk/sources/HeuristicLab 3.3.vsmdi	(revision 2830)
+++ /trunk/sources/HeuristicLab 3.3.vsmdi	(revision 2830)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="UTF-8"?>
+<TestLists xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2006">
+  <TestList name="Lists of Tests" id="8c43106b-9dc1-4907-a29f-aa66a61bf5b6">
+    <RunConfiguration id="f9392825-866f-4434-be36-358db28f0c59" name="Local Test Run" storage="localtestrun.testrunconfig" type="Microsoft.VisualStudio.TestTools.Common.TestRunConfiguration, Microsoft.VisualStudio.QualityTools.Common,   PublicKeyToken=b03f5f7f11d50a3a" />
+  </TestList>
+</TestLists>
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 2830)
@@ -68,9 +68,7 @@
     public ObservableArray(T[] array) {
       this.array = (T[])array.Clone();
-      OnCollectionReset(GetIndexedItems(), new IndexedItem<T>[0]);
     }
     public ObservableArray(IEnumerable<T> collection) {
       array = collection.ToArray();
-      OnCollectionReset(GetIndexedItems(), new IndexedItem<T>[0]);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableCollection.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableCollection.cs	(revision 2830)
@@ -59,5 +59,4 @@
     public ObservableCollection(IEnumerable<T> collection) {
       list = new List<T>(collection);
-      OnItemsAdded(collection);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableDictionary.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableDictionary.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableDictionary.cs	(revision 2830)
@@ -79,5 +79,4 @@
     public ObservableDictionary(IDictionary<TKey, TValue> dictionary) {
       dict = new Dictionary<TKey, TValue>(dictionary);
-      OnItemsAdded(dictionary);
     }
     public ObservableDictionary(int capacity, IEqualityComparer<TKey> comparer) {
@@ -86,5 +85,4 @@
     public ObservableDictionary(IDictionary<TKey, TValue> dictionary, IEqualityComparer<TKey> comparer) {
       dict = new Dictionary<TKey, TValue>(dictionary, comparer);
-      OnItemsAdded(dictionary);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs	(revision 2830)
@@ -66,5 +66,4 @@
       foreach (TItem item in collection)
         dict.Add(GetKeyForItem(item), item);
-      OnItemsAdded(collection);
     }
     protected ObservableKeyedCollection(int capacity, IEqualityComparer<TKey> comparer) {
@@ -76,5 +75,4 @@
       foreach (TItem item in collection)
         dict.Add(GetKeyForItem(item), item);
-      OnItemsAdded(collection);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 2830)
@@ -73,6 +73,4 @@
     public ObservableList(IEnumerable<T> collection) {
       list = new List<T>(collection);
-      OnItemsAdded(GetIndexedItems());
-      OnItemsAdded(collection);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableSet.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableSet.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableSet.cs	(revision 2830)
@@ -51,5 +51,4 @@
     public ObservableSet(IEnumerable<T> collection) {
       set = new HashSet<T>(collection);
-      OnItemsAdded(this);
     }
     public ObservableSet(IEqualityComparer<T> comparer) {
@@ -58,5 +57,4 @@
     public ObservableSet(IEnumerable<T> collection, IEqualityComparer<T> comparer) {
       set = new HashSet<T>(collection, comparer);
-      OnItemsAdded(this);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs	(revision 2830)
@@ -21,7 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
Index: /trunk/sources/HeuristicLab.Core/3.3/Item.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 2830)
@@ -20,13 +20,7 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Text;
-using System.Xml;
 using System.Drawing;
-using System.Resources;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Core {
@@ -61,5 +55,5 @@
     protected virtual void OnChanged(ChangedEventArgs e) {
       if ((e.RegisterChangedObject(this)) && (Changed != null))
-          Changed(this, e);
+        Changed(this, e);
     }
   }
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemArray.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Collections;
 using System.Collections.Generic;
@@ -55,6 +56,12 @@
     public ItemArray() : base() { }
     public ItemArray(int length) : base(length) { }
-    public ItemArray(T[] array) : base(array) { }
-    public ItemArray(IEnumerable<T> collection) : base(collection) { }
+    public ItemArray(T[] array) : base(array) {
+      foreach (T item in this)
+        item.Changed += new ChangedEventHandler(Item_Changed);
+    }
+    public ItemArray(IEnumerable<T> collection) : base(collection) {
+      foreach (T item in this)
+        item.Changed += new ChangedEventHandler(Item_Changed);
+    }
 
     public object Clone() {
@@ -62,9 +69,6 @@
     }
 
-    public IDeepCloneable Clone(Cloner cloner) {
-      T[] items = new T[Length];
-      for (int i = 0; i < items.Length; i++)
-        items[i] = (T)cloner.Clone(this[i]);
-      ItemArray<T> clone = (ItemArray<T>)Activator.CreateInstance(this.GetType(), new object[] { items });
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      ItemArray<T> clone = (ItemArray<T>)Activator.CreateInstance(this.GetType(), this.Select(x => (T)cloner.Clone(x)));
       cloner.RegisterClonedObject(this, clone);
       return clone;
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemCollection.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Collections;
 using System.Collections.Generic;
@@ -56,5 +57,8 @@
     public ItemCollection() : base() { }
     public ItemCollection(int capacity) : base(capacity) { }
-    public ItemCollection(IEnumerable<T> collection) : base(collection) { }
+    public ItemCollection(IEnumerable<T> collection) : base(collection) {
+      foreach (T item in this)
+        item.Changed += new ChangedEventHandler(Item_Changed);
+    }
 
     public object Clone() {
@@ -62,9 +66,6 @@
     }
 
-    public IDeepCloneable Clone(Cloner cloner) {
-      List<T> items = new List<T>();
-      foreach (T item in this)
-        items.Add((T)cloner.Clone(item));
-      ItemCollection<T> clone = (ItemCollection<T>)Activator.CreateInstance(this.GetType(), items);
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      ItemCollection<T> clone = (ItemCollection<T>)Activator.CreateInstance(this.GetType(), this.Select(x => (T)cloner.Clone(x)));
       cloner.RegisterClonedObject(this, clone);
       return clone;
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemList.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemList.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Collections;
 using System.Collections.Generic;
@@ -56,5 +57,8 @@
     public ItemList() : base() { }
     public ItemList(int capacity) : base(capacity) { }
-    public ItemList(IEnumerable<T> collection) : base(collection) { }
+    public ItemList(IEnumerable<T> collection) : base(collection) {
+      foreach (T item in this)
+        item.Changed += new ChangedEventHandler(Item_Changed);
+    }
 
     public object Clone() {
@@ -62,9 +66,6 @@
     }
 
-    public IDeepCloneable Clone(Cloner cloner) {
-      List<T> items = new List<T>();
-      foreach (T item in this)
-        items.Add((T)cloner.Clone(item));
-      ItemList<T> clone = (ItemList<T>)Activator.CreateInstance(this.GetType(), items);
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      ItemList<T> clone = (ItemList<T>)Activator.CreateInstance(this.GetType(), this.Select(x => (T)cloner.Clone(x)));
       cloner.RegisterClonedObject(this, clone);
       return clone;
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemSet.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Collections;
 using System.Collections.Generic;
@@ -55,5 +56,8 @@
 
     public ItemSet() : base() { }
-    public ItemSet(IEnumerable<T> collection) : base(collection) { }
+    public ItemSet(IEnumerable<T> collection) : base(collection) {
+      foreach (T item in this)
+        item.Changed += new ChangedEventHandler(Item_Changed);
+    }
 
     public object Clone() {
@@ -61,9 +65,6 @@
     }
 
-    public IDeepCloneable Clone(Cloner cloner) {
-      List<T> items = new List<T>();
-      foreach (T item in this)
-        items.Add((T)cloner.Clone(item));
-      ItemSet<T> clone = (ItemSet<T>)Activator.CreateInstance(this.GetType(), items);
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      ItemSet<T> clone = (ItemSet<T>)Activator.CreateInstance(this.GetType(), this.Select(x => (T)cloner.Clone(x)));
       cloner.RegisterClonedObject(this, clone);
       return clone;
Index: /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2830)
@@ -74,6 +74,6 @@
     /// </summary>
     protected NamedItem() {
-      name = ItemName;
-      description = ItemDescription;
+      name = string.Empty;
+      description = string.Empty;
     }
     /// <summary>
@@ -83,11 +83,12 @@
     /// <param name="name">The name of the current instance.</param>
     /// <param name="value">The value of the current instance.</param>
-    protected NamedItem(string name)
-      : this() {
+    protected NamedItem(string name) {
       if (name == null) throw new ArgumentNullException();
       this.name = name;
+      description = string.Empty;
     }
-    protected NamedItem(string name, string description)
-      : this(name) {
+    protected NamedItem(string name, string description) {
+      if (name == null) throw new ArgumentNullException();
+      this.name = name;
       this.description = description;
     }
Index: /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Collections.Generic;
 using System.Drawing;
@@ -43,25 +44,18 @@
     private object RestoreEvents {
       get { return null; }
-      set {
-        foreach (T item in this) {
-          item.NameChanging += new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
-          item.NameChanged += new EventHandler(Item_NameChanged);
-          item.Changed += new ChangedEventHandler(Item_Changed);
-        }
-      }
+      set { RegisterItemEvents(this); }
     }
 
     public NamedItemCollection() : base() { }
     public NamedItemCollection(int capacity) : base(capacity) { }
-    public NamedItemCollection(IEnumerable<T> collection) : base(collection) { }
+    public NamedItemCollection(IEnumerable<T> collection) : base(collection) {
+      RegisterItemEvents(this);
+    }
 
     public object Clone() {
       return Clone(new Cloner());
     }
-    public IDeepCloneable Clone(Cloner cloner) {
-      List<T> items = new List<T>();
-      foreach (T item in this)
-        items.Add((T)cloner.Clone(item));
-      NamedItemCollection<T> clone = (NamedItemCollection<T>)Activator.CreateInstance(this.GetType(), items);
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      NamedItemCollection<T> clone = (NamedItemCollection<T>)Activator.CreateInstance(this.GetType(), this.Select(x => (T)cloner.Clone(x)));
       cloner.RegisterClonedObject(this, clone);
       return clone;
@@ -86,17 +80,9 @@
 
     protected override void OnItemsAdded(IEnumerable<T> items) {
-      foreach (T item in items) {
-        item.NameChanging += new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
-        item.NameChanged += new EventHandler(Item_NameChanged);
-        item.Changed += new ChangedEventHandler(Item_Changed);
-      }
+      RegisterItemEvents(items);
       base.OnItemsAdded(items);
     }
     protected override void OnItemsRemoved(IEnumerable<T> items) {
-      foreach (T item in items) {
-        item.NameChanging -= new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
-        item.NameChanged -= new EventHandler(Item_NameChanged);
-        item.Changed -= new ChangedEventHandler(Item_Changed);
-      }
+      DeregisterItemEvents(items);
       base.OnItemsRemoved(items);
     }
@@ -108,9 +94,14 @@
     #endregion
     protected override void OnCollectionReset(IEnumerable<T> items, IEnumerable<T> oldItems) {
-      foreach (T oldItem in oldItems) {
-        oldItem.NameChanging -= new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
-        oldItem.NameChanged -= new EventHandler(Item_NameChanged);
-        oldItem.Changed -= new ChangedEventHandler(Item_Changed);
-      }
+      DeregisterItemEvents(oldItems);
+      RegisterItemEvents(items);
+      base.OnCollectionReset(items, oldItems);
+    }
+    protected override void OnPropertyChanged(string propertyName) {
+      base.OnPropertyChanged(propertyName);
+      OnChanged();
+    }
+
+    private void RegisterItemEvents(IEnumerable<T> items) {
       foreach (T item in items) {
         item.NameChanging += new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
@@ -118,9 +109,11 @@
         item.Changed += new ChangedEventHandler(Item_Changed);
       }
-      base.OnCollectionReset(items, oldItems);
     }
-    protected override void OnPropertyChanged(string propertyName) {
-      base.OnPropertyChanged(propertyName);
-      OnChanged();
+    private void DeregisterItemEvents(IEnumerable<T> items) {
+      foreach (T item in items) {
+        item.NameChanging -= new EventHandler<CancelEventArgs<string>>(Item_NameChanging);
+        item.NameChanged -= new EventHandler(Item_NameChanged);
+        item.Changed -= new ChangedEventHandler(Item_Changed);
+      }
     }
 
Index: /trunk/sources/HeuristicLab.Core/3.3/Scope.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2830)
@@ -20,10 +20,6 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
+using HeuristicLab.Collections;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Collections;
 
 namespace HeuristicLab.Core {
@@ -99,7 +95,6 @@
       clone.Name = Name;
       clone.Description = Description;
-      clone.parent = (IScope)cloner.Clone(parent);
-      clone.Variables = (VariableCollection)cloner.Clone(variables);
-      clone.SubScopes = (ScopeList)cloner.Clone(subScopes);
+      if (variables.Count > 0) clone.Variables = (VariableCollection)cloner.Clone(variables);
+      if (subScopes.Count > 0) clone.SubScopes = (ScopeList)cloner.Clone(subScopes);
       return clone;
     }
Index: /trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/ScopeList.cs	(revision 2830)
@@ -20,13 +20,7 @@
 #endregion
 
-using System;
-using System.Collections;
 using System.Collections.Generic;
-using System.Collections.ObjectModel;
-using System.Text;
-using System.Drawing;
+using System.Linq;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common.Resources;
-using HeuristicLab.Collections;
 
 namespace HeuristicLab.Core {
@@ -34,8 +28,14 @@
   [Item("ScopeList", "Represents a list of scopes.")]
   [Creatable("Test")]
-  public class ScopeList : ItemList<IScope> {
+  public sealed class ScopeList : ItemList<IScope> {
     public ScopeList() : base() { }
     public ScopeList(int capacity) : base(capacity) { }
     public ScopeList(IEnumerable<IScope> collection) : base(collection) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      ScopeList clone = new ScopeList(this.Select(x => (IScope)cloner.Clone(x)));
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Core/3.3/Variable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2830)
@@ -53,5 +53,5 @@
     public Variable()
       : base("Anonymous") {
-      Value = null;
+      this.value = null;
     }
     /// <summary>
@@ -61,7 +61,21 @@
     /// <param name="name">The name of the current instance.</param>
     /// <param name="value">The value of the current instance.</param>
+    public Variable(string name)
+      : base(name) {
+      this.value = null;
+    }
+    public Variable(string name, string description)
+      : base(name, description) {
+      this.value = null;
+    }
     public Variable(string name, IItem value)
       : base(name) {
-      Value = value;
+      this.value = value;
+      this.value.Changed += new ChangedEventHandler(Value_Changed);
+    }
+    public Variable(string name, string description, IItem value)
+      : base(name, description) {
+      this.value = value;
+      this.value.Changed += new ChangedEventHandler(Value_Changed);
     }
 
@@ -72,9 +86,6 @@
     /// <returns>The cloned object as <see cref="Variable"/>.</returns>
     public override IDeepCloneable Clone(Cloner cloner) {
-      Variable clone = new Variable();
+      Variable clone = new Variable(Name, Description, (IItem)cloner.Clone(value));
       cloner.RegisterClonedObject(this, clone);
-      clone.Name = Name;
-      clone.Description = Description;
-      clone.Value = (IItem)cloner.Clone(value);
       return clone;
     }
Index: /trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs	(revision 2829)
+++ /trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs	(revision 2830)
@@ -21,4 +21,5 @@
 
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -27,8 +28,14 @@
   [Item("VariableCollection", "Represents a collection of variables.")]
   [Creatable("Test")]
-  public class VariableCollection : NamedItemCollection<IVariable> {
+  public sealed class VariableCollection : NamedItemCollection<IVariable> {
     public VariableCollection() : base() { }
     public VariableCollection(int capacity) : base(capacity) { }
     public VariableCollection(IEnumerable<IVariable> collection) : base(collection) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      VariableCollection clone = new VariableCollection(this.Select(x => (IVariable)cloner.Clone(x)));
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj	(revision 2829)
+++ /trunk/sources/HeuristicLab.Evolutionary/3.3/HeuristicLab.Evolutionary-3.3.csproj	(revision 2830)
@@ -82,4 +82,5 @@
   <ItemGroup>
     <None Include="HeuristicLabEvolutionaryPlugin.cs.frame" />
+    <Compile Include="PopulationCreator.cs" />
     <Compile Include="HeuristicLabEvolutionaryPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs	(revision 2830)
+++ /trunk/sources/HeuristicLab.Evolutionary/3.3/PopulationCreator.cs	(revision 2830)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Evolutionary {
+  /// <summary>
+  /// An operator which creates a new population of solutions.
+  /// </summary>
+  [Item("PopulationCreator", "An operator which creates a new population of solutions.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class PopulationCreator : SingleSuccessorOperator {
+    public ValueLookupParameter<IntData> PopulationSizeParameter {
+      get { return (ValueLookupParameter<IntData>)Parameters["PopulationSize"]; }
+    }
+    public ValueLookupParameter<IOperator> SolutionCreatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["SolutionCreator"]; }
+    }
+    public ValueLookupParameter<IOperator> SolutionEvaluatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["SolutionEvaluator"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+
+    public PopulationCreator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IntData>("PopulationSize", "The number of individuals that should be created."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("SolutionCreator", "The operator which is used to create new solutions."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("SolutionEvaluator", "The operator which is used to evaluate new solutions."));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope which represents the population."));
+    }
+
+    public override IExecutionSequence Apply() {
+      int size = PopulationSizeParameter.ActualValue.Value;
+      IOperator creator = SolutionCreatorParameter.ActualValue;
+      IOperator evaluator = SolutionEvaluatorParameter.ActualValue;
+
+      if (CurrentScope.SubScopes.Count > 0) throw new InvalidOperationException("Population is not empty. PopulationCreator cannot be applied on scopes which already contain sub-scopes.");
+
+      for (int i = 0; i < size; i++)
+        CurrentScope.SubScopes.Add(new Scope(i.ToString()));
+
+      ExecutionContextCollection next = new ExecutionContextCollection();
+      for (int i = 0; i < CurrentScope.SubScopes.Count; i++) {
+        if (creator != null) next.Add(ExecutionContext.CreateContext(creator, CurrentScope.SubScopes[i]));
+        if (evaluator != null) next.Add(ExecutionContext.CreateContext(evaluator, CurrentScope.SubScopes[i]));
+      }
+      next.Add(base.Apply());
+      return next;
+    }
+  }
+}
